diff --git a/sys/contrib/dev/acpica/source/tools/acpixtract/acpixtract.c b/sys/contrib/dev/acpica/source/tools/acpixtract/acpixtract.c
index 32f40f52d0..be9a5210de 100644
--- a/sys/contrib/dev/acpica/source/tools/acpixtract/acpixtract.c
+++ b/sys/contrib/dev/acpica/source/tools/acpixtract/acpixtract.c
@@ -1,6 +1,7 @@
 /******************************************************************************
  *
- * Module Name: acpixtract - convert ascii ACPI tables to binary
+ * Module Name: acpixtract - Top level functions to convert ascii/hex
+ *                           ACPI tables to the original binary tables
  *
  *****************************************************************************/
 
@@ -8,7 +9,7 @@
  *
  * 1. Copyright Notice
  *
- * Some or all of this work - Copyright (c) 1999 - 2017, Intel Corp.
+ * Some or all of this work - Copyright (c) 1999 - 2018, Intel Corp.
  * All rights reserved.
  *
  * 2. License
@@ -152,13 +153,6 @@
 #include "acpixtract.h"
 
 
-/* Local prototypes */
-
-static BOOLEAN
-AxIsFileAscii (
-    FILE                    *Handle);
-
-
 /******************************************************************************
  *
  * FUNCTION:    AxExtractTables
@@ -210,21 +204,20 @@ AxExtractTables (
 
     if (Signature)
     {
-        strncpy (UpperSignature, Signature, 4);
-        UpperSignature[4] = 0;
+        strncpy (UpperSignature, Signature, ACPI_NAME_SIZE);
         AcpiUtStrupr (UpperSignature);
 
         /* Are there enough instances of the table to continue? */
 
         AxNormalizeSignature (UpperSignature);
-
         Instances = AxCountTableInstances (InputPathname, UpperSignature);
+
         if (Instances < MinimumInstances)
         {
             printf ("Table [%s] was not found in %s\n",
                 UpperSignature, InputPathname);
             fclose (InputFile);
-            return (-1);
+            return (0);             /* Don't abort */
         }
 
         if (Instances == 0)
@@ -238,6 +231,28 @@ AxExtractTables (
 
     while (fgets (Gbl_LineBuffer, AX_LINE_BUFFER_SIZE, InputFile))
     {
+        /*
+         * Check up front if we have a header line of the form:
+         * DSDT @ 0xdfffd0c0 (10999 bytes)
+         */
+        if (AX_IS_TABLE_BLOCK_HEADER &&
+            (State == AX_STATE_EXTRACT_DATA))
+        {
+            /* End of previous table, start of new table */
+
+            if (ThisTableBytesWritten)
+            {
+                printf (AX_TABLE_INFO_FORMAT, ThisSignature, ThisTableBytesWritten,
+                    ThisTableBytesWritten, Gbl_OutputFilename);
+            }
+            else
+            {
+                Gbl_TableCount--;
+            }
+
+            State = AX_STATE_FIND_HEADER;
+        }
+
         switch (State)
         {
         case AX_STATE_FIND_HEADER:
@@ -301,10 +316,15 @@ AxExtractTables (
 
         case AX_STATE_EXTRACT_DATA:
 
+            if (!AxIsHexDataLine ())
+            {
+                continue;   /* Toss any lines that are not raw hex data */
+            }
+
             /* Empty line or non-data line terminates the data block */
 
-            BytesConverted = AxProcessOneTextLine (
-                OutputFile, ThisSignature, ThisTableBytesWritten);
+            BytesConverted = AxConvertAndWrite (OutputFile, ThisSignature,
+                ThisTableBytesWritten);
             switch (BytesConverted)
             {
             case 0:
@@ -341,14 +361,8 @@ AxExtractTables (
     {
         /* Received an input file EOF while extracting data */
 
-        printf (AX_TABLE_INFO_FORMAT,
-            ThisSignature, ThisTableBytesWritten, Gbl_OutputFilename);
-    }
-
-    if (Gbl_TableCount > 1)
-    {
-        printf ("\n%u binary ACPI tables extracted\n",
-            Gbl_TableCount);
+        printf (AX_TABLE_INFO_FORMAT, ThisSignature, ThisTableBytesWritten,
+            ThisTableBytesWritten, Gbl_OutputFilename);
     }
 
     if (OutputFile)
@@ -385,7 +399,7 @@ AxExtractToMultiAmlFile (
     int                     Status = 0;
     unsigned int            TotalBytesWritten = 0;
     unsigned int            ThisTableBytesWritten = 0;
-    unsigned int             BytesConverted;
+    unsigned int            BytesConverted;
     char                    ThisSignature[4];
     unsigned int            State = AX_STATE_FIND_HEADER;
 
@@ -421,6 +435,28 @@ AxExtractToMultiAmlFile (
 
     while (fgets (Gbl_LineBuffer, AX_LINE_BUFFER_SIZE, InputFile))
     {
+        /*
+         * Check up front if we have a header line of the form:
+         * DSDT @ 0xdfffd0c0 (10999 bytes)
+         */
+        if (AX_IS_TABLE_BLOCK_HEADER &&
+            (State == AX_STATE_EXTRACT_DATA))
+        {
+            /* End of previous table, start of new table */
+
+            if (ThisTableBytesWritten)
+            {
+                printf (AX_TABLE_INFO_FORMAT, ThisSignature, ThisTableBytesWritten,
+                    ThisTableBytesWritten, Gbl_OutputFilename);
+            }
+            else
+            {
+                Gbl_TableCount--;
+            }
+
+            State = AX_STATE_FIND_HEADER;
+        }
+
         switch (State)
         {
         case AX_STATE_FIND_HEADER:
@@ -451,9 +487,14 @@ AxExtractToMultiAmlFile (
 
         case AX_STATE_EXTRACT_DATA:
 
+            if (!AxIsHexDataLine ())
+            {
+                continue;   /* Toss any lines that are not raw hex data */
+            }
+
             /* Empty line or non-data line terminates the data block */
 
-            BytesConverted = AxProcessOneTextLine (
+            BytesConverted = AxConvertAndWrite (
                 OutputFile, ThisSignature, ThisTableBytesWritten);
             switch (BytesConverted)
             {
@@ -487,8 +528,8 @@ AxExtractToMultiAmlFile (
     {
         /* Received an input file EOF or error while writing data */
 
-        printf (AX_TABLE_INFO_FORMAT,
-            ThisSignature, ThisTableBytesWritten, Gbl_OutputFilename);
+        printf (AX_TABLE_INFO_FORMAT, ThisSignature, ThisTableBytesWritten,
+            ThisTableBytesWritten, Gbl_OutputFilename);
     }
 
     printf ("\n%u binary ACPI tables extracted and written to %s (%u bytes)\n",
@@ -502,7 +543,7 @@ AxExtractToMultiAmlFile (
 
 /******************************************************************************
  *
- * FUNCTION:    AxListTables
+ * FUNCTION:    AxListAllTables
  *
  * PARAMETERS:  InputPathname       - Filename for acpidump file
  *
@@ -514,13 +555,13 @@ AxExtractToMultiAmlFile (
  ******************************************************************************/
 
 int
-AxListTables (
+AxListAllTables (
     char                    *InputPathname)
 {
     FILE                    *InputFile;
-    size_t                  HeaderSize;
     unsigned char           Header[48];
-    ACPI_TABLE_HEADER       *TableHeader = (ACPI_TABLE_HEADER *) (void *) Header;
+    UINT32                  ByteCount = 0;
+    unsigned int            State = AX_STATE_FIND_HEADER;
 
 
     /* Open input in text mode, output is in binary mode */
@@ -538,133 +579,74 @@ AxListTables (
         return (-1);
     }
 
-    /* Dump the headers for all tables found in the input file */
+    /* Info header */
+
+    printf ("\n Signature  Length    Version Oem       Oem         "
+        "Oem         Compiler Compiler\n");
+    printf (  "                              Id        TableId     "
+        "RevisionId  Name     Revision\n");
+    printf (  " _________  __________  ____  ________  __________  "
+        "__________  _______  __________\n\n");
 
-    printf ("\nSignature  Length      Revision   OemId    OemTableId"
-        "   OemRevision CompilerId CompilerRevision\n\n");
+    /* Dump the headers for all tables found in the input file */
 
     while (fgets (Gbl_LineBuffer, AX_LINE_BUFFER_SIZE, InputFile))
     {
-        /* Ignore empty lines and lines that start with a space */
+        /* Ignore empty lines */
 
-        if (AxIsEmptyLine (Gbl_LineBuffer) ||
-            (Gbl_LineBuffer[0] == ' '))
+        if (AxIsEmptyLine (Gbl_LineBuffer))
         {
             continue;
         }
 
-        /* Get the 36 byte header and display the fields */
-
-        HeaderSize = AxGetTableHeader (InputFile, Header);
-        if (HeaderSize < 16)
+        /*
+         * Check up front if we have a header line of the form:
+         * DSDT @ 0xdfffd0c0 (10999 bytes)
+         */
+        if (AX_IS_TABLE_BLOCK_HEADER &&
+            (State == AX_STATE_EXTRACT_DATA))
         {
-            continue;
+            State = AX_STATE_FIND_HEADER;
         }
 
-        /* RSDP has an oddball signature and header */
-
-        if (!strncmp (TableHeader->Signature, "RSD PTR ", 8))
+        switch (State)
         {
-            AxCheckAscii ((char *) &Header[9], 6);
-            printf ("%7.4s                          \"%6.6s\"\n", "RSDP",
-                &Header[9]);
-            Gbl_TableCount++;
-            continue;
-        }
+        case AX_STATE_FIND_HEADER:
 
-        /* Minimum size for table with standard header */
+            ByteCount = 0;
+            if (!AxIsDataBlockHeader ())
+            {
+                continue;
+            }
 
-        if (HeaderSize < sizeof (ACPI_TABLE_HEADER))
-        {
+            State = AX_STATE_EXTRACT_DATA;
             continue;
-        }
 
-        if (!AcpiUtValidNameseg (TableHeader->Signature))
-        {
-            continue;
-        }
+        case AX_STATE_EXTRACT_DATA:
 
-        /* Signature and Table length */
+            /* Ignore any lines that don't look like a data line */
 
-        Gbl_TableCount++;
-        printf ("%7.4s   0x%8.8X", TableHeader->Signature,
-            TableHeader->Length);
+            if (!AxIsHexDataLine ())
+            {
+                continue;   /* Toss any lines that are not raw hex data */
+            }
 
-        /* FACS has only signature and length */
+            /* Convert header to hex and display it */
 
-        if (ACPI_COMPARE_NAME (TableHeader->Signature, "FACS"))
-        {
-            printf ("\n");
+            ByteCount += AxConvertToBinary (Gbl_LineBuffer, &Header[ByteCount]);
+            if (ByteCount >= sizeof (ACPI_TABLE_HEADER))
+            {
+                AxDumpTableHeader (Header);
+                State = AX_STATE_FIND_HEADER;
+            }
             continue;
-        }
-
-        /* OEM IDs and Compiler IDs */
-
-        AxCheckAscii (TableHeader->OemId, 6);
-        AxCheckAscii (TableHeader->OemTableId, 8);
-        AxCheckAscii (TableHeader->AslCompilerId, 4);
 
-        printf (
-            "     0x%2.2X    \"%6.6s\"  \"%8.8s\"   0x%8.8X"
-            "    \"%4.4s\"     0x%8.8X\n",
-            TableHeader->Revision, TableHeader->OemId,
-            TableHeader->OemTableId, TableHeader->OemRevision,
-            TableHeader->AslCompilerId, TableHeader->AslCompilerRevision);
+        default:
+            break;
+        }
     }
 
     printf ("\nFound %u ACPI tables in %s\n", Gbl_TableCount, InputPathname);
     fclose (InputFile);
     return (0);
 }
-
-
-/*******************************************************************************
- *
- * FUNCTION:    AxIsFileAscii
- *
- * PARAMETERS:  Handle              - To open input file
- *
- * RETURN:      TRUE if file is entirely ASCII and printable
- *
- * DESCRIPTION: Verify that the input file is entirely ASCII.
- *
- ******************************************************************************/
-
-static BOOLEAN
-AxIsFileAscii (
-    FILE                    *Handle)
-{
-    UINT8                   Byte;
-
-
-    /* Read the entire file */
-
-    while (fread (&Byte, 1, 1, Handle) == 1)
-    {
-        /* Check for an ASCII character */
-
-        if (!ACPI_IS_ASCII (Byte))
-        {
-            goto ErrorExit;
-        }
-
-        /* Ensure character is either printable or a "space" char */
-
-        else if (!isprint (Byte) && !isspace (Byte))
-        {
-            goto ErrorExit;
-        }
-    }
-
-    /* File is OK (100% ASCII) */
-
-    fseek (Handle, 0, SEEK_SET);
-    return (TRUE);
-
-ErrorExit:
-
-    printf ("File is binary (contains non-text or non-ascii characters)\n");
-    fseek (Handle, 0, SEEK_SET);
-    return (FALSE);
-
-}
diff --git a/sys/contrib/dev/acpica/source/tools/acpixtract/acpixtract.h b/sys/contrib/dev/acpica/source/tools/acpixtract/acpixtract.h
index abe2a1903c..88b16670ec 100644
--- a/sys/contrib/dev/acpica/source/tools/acpixtract/acpixtract.h
+++ b/sys/contrib/dev/acpica/source/tools/acpixtract/acpixtract.h
@@ -8,7 +8,7 @@
  *
  * 1. Copyright Notice
  *
- * Some or all of this work - Copyright (c) 1999 - 2017, Intel Corp.
+ * Some or all of this work - Copyright (c) 1999 - 2018, Intel Corp.
  * All rights reserved.
  *
  * 2. License
@@ -180,9 +180,9 @@
 #define AX_REQUIRED_TABLE           1
 
 #define AX_UTILITY_NAME             "ACPI Binary Table Extraction Utility"
-#define AX_SUPPORTED_OPTIONS        "ahlms:v"
+#define AX_SUPPORTED_OPTIONS        "afhlms:v^"
 #define AX_MULTI_TABLE_FILENAME     "amltables.dat"
-#define AX_TABLE_INFO_FORMAT        "Acpi table [%4.4s] - %7u bytes written to %s\n"
+#define AX_TABLE_INFO_FORMAT        "  %4.4s - %7u bytes written (0x%8.8X) - %s\n"
 
 /* Extraction states */
 
@@ -193,6 +193,9 @@
 
 #define AX_LINE_BUFFER_SIZE         256
 #define AX_MIN_BLOCK_HEADER_LENGTH  6   /* strlen ("DSDT @") */
+#define AX_HEX_DATA_LENGTH          49  /*  (3 * 16) + 1 for the colon delimiter */
+#define AX_IS_TABLE_BLOCK_HEADER    (strlen (Gbl_LineBuffer) < AX_HEX_DATA_LENGTH) && \
+                                    (strstr (Gbl_LineBuffer, " @ "))
 
 
 typedef struct AxTableInfo
@@ -210,11 +213,12 @@ typedef struct AxTableInfo
 ACPI_GLOBAL (char,           Gbl_LineBuffer[AX_LINE_BUFFER_SIZE]);
 ACPI_GLOBAL (char,           Gbl_HeaderBuffer[AX_LINE_BUFFER_SIZE]);
 ACPI_GLOBAL (char,           Gbl_InstanceBuffer[AX_LINE_BUFFER_SIZE]);
-
 ACPI_GLOBAL (AX_TABLE_INFO, *Gbl_TableListHead);
 ACPI_GLOBAL (char,           Gbl_OutputFilename[32]);
 ACPI_GLOBAL (unsigned char,  Gbl_BinaryData[16]);
 ACPI_GLOBAL (unsigned int,   Gbl_TableCount);
+ACPI_GLOBAL (BOOLEAN,        Gbl_ForceExtraction);
+
 
 /*
  * acpixtract.c
@@ -230,18 +234,13 @@ AxExtractToMultiAmlFile (
     char                    *InputPathname);
 
 int
-AxListTables (
+AxListAllTables (
     char                    *InputPathname);
 
 
 /*
  * axutils.c
  */
-size_t
-AxGetTableHeader (
-    FILE                    *InputFile,
-    unsigned char           *OutputData);
-
 unsigned int
 AxCountTableInstances (
     char                    *InputPathname,
@@ -261,21 +260,33 @@ AxCheckAscii (
     char                    *Name,
     int                     Count);
 
-int
+BOOLEAN
+AxIsFileAscii (
+    FILE                    *Handle);
+
+BOOLEAN
+AxIsHexDataLine (
+    void);
+
+BOOLEAN
 AxIsEmptyLine (
     char                    *Buffer);
 
-int
+BOOLEAN
 AxIsDataBlockHeader (
     void);
 
 long
-AxProcessOneTextLine (
+AxConvertAndWrite (
     FILE                    *OutputFile,
     char                    *ThisSignature,
     unsigned int            ThisTableBytesWritten);
 
 size_t
-AxConvertLine (
+AxConvertToBinary (
     char                    *InputLine,
     unsigned char           *OutputData);
+
+void
+AxDumpTableHeader (
+    unsigned char           *Header);
diff --git a/sys/contrib/dev/acpica/source/tools/acpixtract/axmain.c b/sys/contrib/dev/acpica/source/tools/acpixtract/axmain.c
index f5aa710113..939fdcd0b5 100644
--- a/sys/contrib/dev/acpica/source/tools/acpixtract/axmain.c
+++ b/sys/contrib/dev/acpica/source/tools/acpixtract/axmain.c
@@ -8,7 +8,7 @@
  *
  * 1. Copyright Notice
  *
- * Some or all of this work - Copyright (c) 1999 - 2017, Intel Corp.
+ * Some or all of this work - Copyright (c) 1999 - 2018, Intel Corp.
  * All rights reserved.
  *
  * 2. License
@@ -176,10 +176,12 @@ DisplayUsage (
     ACPI_USAGE_HEADER ("acpixtract [option] <InputFile>");
 
     ACPI_OPTION ("-a",                  "Extract all tables, not just DSDT/SSDT");
+    ACPI_OPTION ("-f",                  "Force extraction, even if there are errors");
     ACPI_OPTION ("-l",                  "List table summaries, do not extract");
     ACPI_OPTION ("-m",                  "Extract multiple DSDT/SSDTs to a single file");
     ACPI_OPTION ("-s <signature>",      "Extract all tables with <signature>");
     ACPI_OPTION ("-v",                  "Display version information");
+    ACPI_OPTION ("-vd",                 "Display build date and time");
 
     ACPI_USAGE_TEXT ("\nExtract binary ACPI tables from text acpidump output\n");
     ACPI_USAGE_TEXT ("Default invocation extracts the DSDT and all SSDTs\n");
@@ -207,6 +209,7 @@ main (
 
     Gbl_TableCount = 0;
     Gbl_TableListHead = NULL;
+    Gbl_ForceExtraction = FALSE;
     AxAction = AX_EXTRACT_AML_TABLES; /* Default: DSDT & SSDTs */
 
     ACPI_DEBUG_INITIALIZE (); /* For debug version only */
@@ -228,6 +231,11 @@ main (
         AxAction = AX_EXTRACT_ALL;          /* Extract all tables found */
         break;
 
+    case 'f':
+
+        Gbl_ForceExtraction = TRUE;           /* Ignore errors */
+        break;
+
     case 'l':
 
         AxAction = AX_LIST_ALL;             /* List tables only, do not extract */
@@ -243,9 +251,25 @@ main (
         AxAction = AX_EXTRACT_SIGNATURE;    /* Extract only tables with this sig */
         break;
 
-    case 'v': /* -v: (Version): signon already emitted, just exit */
+    case 'v':
 
-        return (0);
+        switch (AcpiGbl_Optarg[0])
+        {
+        case '^':  /* -v: (Version): signon already emitted, just exit */
+
+            exit (0);
+
+        case 'd':
+
+            printf (ACPI_COMMON_BUILD_TIME);
+            return (0);
+
+        default:
+
+            printf ("Unknown option: -v%s\n", AcpiGbl_Optarg);
+            return (-1);
+        }
+        break;
 
     case 'h':
     default:
@@ -279,7 +303,7 @@ main (
 
     case AX_LIST_ALL:
 
-        Status = AxListTables (Filename);
+        Status = AxListAllTables (Filename);
         break;
 
     case AX_EXTRACT_SIGNATURE:
